//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

void* linkedchannellist = NULL;

struct weircd_channel* cdat(CHANNEL chan) {
	return linkedlist_GetData(chan);
}
CHANNEL cyclechan;
void chan_CycleInit() {
	cyclechan = linkedchannellist;
}
CHANNEL chan_DoCycle() {
	if (cyclechan == NULL) {return NULL;}
	void* retval = cyclechan;
	cyclechan = linkedlist_NextItem(cyclechan);
	return retval;
}
CHANNEL chan_FindByName(const char* channame) {
	chan_CycleInit();
	CHANNEL chan = chan_DoCycle();
	while (chan != NOCHAN) {
		if (strcasecmp(cdat(chan)->name,channame) == 0) {
			return chan;
		}
		chan = chan_DoCycle();
	}
	return NOCHAN;
}
CHANNEL chan_Add(const char* channame) {
	CHANNEL chan = chan_FindByName(channame);
	if (chan != NOCHAN) {return chan;}
	struct weircd_channel cdata;
	memset(&cdata,0,sizeof(cdata));
	strncpy(cdata.name, channame, MAXCHANNELNAMELEN);
	cdata.name[MAXCHANNELNAMELEN] = 0;
	cdata.creationtime = ts();
	void* item = linkedlist_Append(&linkedchannellist,&cdata,sizeof(cdata));
	if (item == NULL) {return NOCHAN;}
	return item;
}
void chan_FreeBan(CHANNEL chan, int banid) {
	if (chan == NOCHAN) {return;}
	if (cdat(chan)->ban[banid]->actor != NULL) {
		free(cdat(chan)->ban[banid]->actor);
	}
	if (cdat(chan)->ban[banid]->mask != NULL) {
		free(cdat(chan)->ban[banid]->mask);
	}
	free(cdat(chan)->ban[banid]);
}
void chan_Delete(CHANNEL id) {
	if (id == NOCHAN) {return;}
	int r = 0;
	while (r < MAXBANSPERCHAN) {
		if (cdat(id)->ban[r] != NULL) {
			chan_FreeBan(id,r);
		}
		r++;
	}
	if (cdat(id)->password != NULL) {
		free(cdat(id)->password);
	}
	linkedlist_RemoveItem(&linkedchannellist,id);
}
