//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

int floodpointmax() {
	if (config_IntVal("floodlevel") == FLOODLEVEL_STRICT) {
		return 10;
	}
	if (config_IntVal("floodlevel") == FLOODLEVEL_MEDIUM) {
		return 15;
	}
	if (config_IntVal("floodlevel") == FLOODLEVEL_SOFT) {
		return 20;
	}
	return 15;
}

long lastfloodtime = 0;
void floodmanager() {
	int floodmax = floodpointmax();
	usr_CycleInit();
	int dolowering = 0;
	if (lastfloodtime < ts()) {dolowering = 1;}
	USER u = usr_DoCycle();
	while (u != NOUSER) {
		if (udat(u)->pleaseremove == 0 && udat(u)->hopcount <= 0) {
			if (dolowering == 1) {
				udat(u)->floodprotect.floodpoints -= 2;
				if (udat(u)->floodprotect.floodpoints < 0) {
					udat(u)->floodprotect.floodpoints = 0;
				}
			}
			if (udat(u)->floodprotect.floodpoints > floodmax) {
				if (option_noexcessflood == 0 && udat(u)->mode_noflood == 0 && udat(u)->mode_servicesbot == 0) {
					usnd(u,"ERROR :Closing Link: Excess flood");
					userQuit(u,USERQUIT_EXCESSFLOOD);
				}else{
					udat(u)->floodprotect.floodpoints = 0;
				}
			}
		}
		u = usr_DoCycle();
	}
	lastfloodtime = ts();
}
int mainloop_go() {
	while (willquit == 0) {
		so_SelectWait();
		usr_PingAndRemove();
		floodmanager();
		userman_CheckConnections();
		userman_ProceedReceiving();
		floodmanager();
		expiregklines();
		usr_PingAndRemove();
		userman_ProceedSending();
		FakeUsers_ProceedAll();
		usr_PingAndRemove();
		ips_AutoRemove();
		//linksProceed();
	}
	//linktcp_closeforshutdown();
	//close down modules (services, linking, ...)
	modules_ShutdownAll();
	//close down user connections
	
	//save glines & klines
	saveglines();
	saveklines();
	//clear config related stuff
	listdata_ClearNew();
	return 0;
}
