//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

// ----- This is the WeIRCd convenience API for channel tracking ----- //
  /* This api offers creation of channel tracker objects that
     parses any kind of event messages related to channels
     you are in, the users that are inside those channels
     and their status.
     To make it do that, simply create a new tracker object
     and then pass every single line you receive from an
     IRC server via weircd_channeltracker_RawLine() and
     it will track all changes. */

struct ctrackerevent {
	int event; // a CTEVENT_* value
	void* data1;
	void* data2;
	void* data3;
	void* data4;
};

//see this file for channel tracker event types
#include "weircd_api_channeltracker_eventtypes.h"


struct ctrackerevents {
	int eventcount;
	struct ctrackerevent** eventlist;
};
  
int weircd_channeltracker_New();
  /* Create a new channel tracker object. Returns a respective
     integer handle that represents the object. Returns -1 if
     creation failed. */

struct ctrackerevents* weircd_channeltracker_RawLine(int handle, const char* line);
  /* Pass a raw IRC line to the tracker represented by the
     handle so it parses it and, if necessary, tracks the
     changes resulting of it */

int weircd_channeltracker_query_IsMeInChannel(int handle, const char* channel);
  /* Returns 0 if yourself are currently located in a channel
     in the channel tracker'ss internal state. Otherwise -1 */

int weircd_channeltracker_query_IsUserInChannel(int handle, const char* user, const char* channel);
  /* Returns 0 if in the channel tracker's state, a user with the
     nickname 'user' is inside the specified channel */