//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

/* moduleschanneltrackerapi.c - Channel tracker api implementation */
/* ----------------------- */
/* This is a wrapper around the channel tracker manager/channel tracker parser to
   be used by modules through weircd_api_channeltracker.h. See moduleschanneltrackerapi.h
   for details. */

#include "weircd.h"

struct ctrackermapi_ctracker {
	int handle;
	void* ctracker;
};
struct ctrackermapi_Item {
	void* parentmodule; //modules manager pointer to the respective module
	void* listoftrackers; //linked list of channel trackers
};
void* ctrackermapilist = NULL;
int weircd_channeltracker_New() {
	if (module_AccessAllowed(MODAREA_GENERICFUNC) != 0) {
		return -1;	
	}
	return -1; //we cannot do this yet
}
void* ctrackerapi_GetEntryByMPtr(void* module) {
	void* item = ctrackermapilist;
	while (item != NULL) {
		struct ctrackermapi_Item* c = linkedlist_GetData(item);
		if (c->parentmodule == module) {
			return item;
		}
		item = linkedlist_NextItem(item);
	}
	return NULL;
}
void* ctrackerapi_GetEntryByName(const char* name) {
	void* ptr = modman_GetPtrByName(name);
	if (ptr == NULL) {return NULL;}
	return ctrackerapi_GetEntryByMPtr(ptr);
}
void ctrackerapi_ClearEntry(void* entry) {
	struct ctrackermapi_Item* c = linkedlist_GetData(entry);
	while (c->listoftrackers != NULL) {
		struct ctrackermapi_ctracker* trackerinfo = linkedlist_GetData(c->listoftrackers);
		ctracker_Free(trackerinfo->ctracker);
		linkedlist_RemoveItem(&c->listoftrackers,c->listoftrackers);
	}
	linkedlist_RemoveItem(&ctrackermapilist,entry);
}
void ctrackerapi_ClearModule(const char* name) {
	void* mitem = ctrackerapi_GetEntryByName(name);
	if (mitem == NULL) {return;}
	ctrackerapi_ClearEntry(mitem);
}