//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

/* modulesfakeuapi.c - Implementing weircd_api_fakeusers.h */
/* -------------------------- */
/* This object file allows modules the creation of virtual
   client connections on which they can sent and receive stuff.
   Apart from this, it also implements some internal functions
   to manage those virtual users and to get rid of them when
   a module gets unloaded and doesn't trash them itself. */

/* Some of those additional managing functions implemented are: */

/* Dispose of fake users */
void FakeUsers_Delete(void* module, void* fakeuser); /* Deletes a fake user */
void FakeUsers_ShutdownForModule(const char* name); /* Deletes all fake users of a module (by name) */
void FakeUsers_DeleteAll(void* module); /* Deletes all fake users of a module (by a modulesmanager.c pointer) */

/* Obtain information */
void* FakeUsers_GetModuleFakeEntryByPtr(void* ptr); /* Get pointer to internal fake api module list entry by using modulesmanager.c pointer */

/* Do not use the following when you don't know what you're doing */
void* FakeUsers_Create(void* module); /* Add a fake user. Called internally. */
void FakeUsers_DropUserReference(void* connection); /* Drop reference to user entry.
                                                       Called internally when associated user
						       got disconnected. */ 

//void* FakeUsers_GetFakeUserByHandle(int HANDLE, void* moduleentry);
USER FakeUsers_GetUserPtr(int handle, void* moduleentry);
void FakeUsers_ProceedAll(); /* To be called by the main loop */