//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "weircd.h"

#define PROCESSLENGTH 2000
#ifndef WIN
void strlwr(char *s) {
	while (*s)
	{       *s = tolower(*s);
	s++;
	}
}
#endif
void strupper(char *s) {
	while (*s)
	{       *s = toupper(*s);
	s++;
	}
}
int isnumber(const char* s) {
	if (strlen(s) <= 0) {return -1;}
	unsigned int r = 0;
	while (r < strlen(s)) {
		if (s[r] < '0' || s[r] > '9') {return -1;}
		r++;
	}
	return 0;
}
char spacesbuffer[500];
const char* spaces(int count) {
	memset(&spacesbuffer,0,499);
	int r = 0;
	while (r < count && r < 450) {
		spacesbuffer[r] = ' ';
		r++;
	}
	return spacesbuffer;
}
/*int stringisinstring(const char* longstring,const char* shortstring) { //TODO: recode this
	char mlongstring[PROCESSLENGTH];strncpy(mlongstring,longstring,PROCESSLENGTH - 2);mlongstring[PROCESSLENGTH - 2] = 0;
	char mshortstring[PROCESSLENGTH];strncpy(mshortstring,shortstring,PROCESSLENGTH - 2);mshortstring[PROCESSLENGTH - 2] = 0;
	unsigned int r;
	if (strlen(mlongstring) == 0) {return -1;}
	if (strlen(mshortstring) == 0) {return 0;}
	if (strlen(mshortstring) > strlen(mlongstring)) {return -1;}
	if (strlen(mshortstring) == strlen(mlongstring) && strcmp(mlongstring,mshortstring) != 0) {return -1;}
	strlwr(mshortstring);strlwr(mlongstring);
	r = 0;
	unsigned int vk;
	int isok;
	// -- some comments in here that show how I calculated around to get the proper way of doing it :)
	//longstring: blablubb - 8
	//shortstring: abl - 3
	while (r < strlen(mlongstring) - (strlen(mshortstring) - 1)) {// 8 - 2
		if (mlongstring[r] == mshortstring[0]) {//r = 2, blABLubb Abl
			vk = r;isok = 0;
			while (vk < strlen(mlongstring) && vk - r < strlen(mshortstring)) {
				if (mlongstring[vk] != mshortstring[vk - r]) {break;}
				if (mlongstring[vk] == mshortstring[vk - r] && vk - r == strlen(mshortstring) - 1) {isok = 1;break;}
				vk += 1;
			}
			if (isok == 1) {return 0;}
		}
		r += 1;
	}
	return -1;
}*/
void stradd(char* old, const char* new, int maxlen) {
	int addlen = maxlen;
	addlen -= strlen(old);
	strncat(old,new,addlen);
	old[maxlen] = 0;
}
int charpos(const char* stringle, char letter) {
	unsigned int z;
	z = 0;
	if (strlen(stringle) > 0) {
		while (z < strlen(stringle)) {
			if (stringle[z] == 0) {
				return -1;
			}
			if (stringle[z] == letter) {
				return z;
			}
			z += 1;
		}
		return -1;
	}else{
		return -1;
	}
}
int charposfromright(const char* stringle, char letter) {
	unsigned int z;
	z = strlen(stringle);
	if (strlen(stringle) > 0) {
		while (z > 0) {
			z -= 1;
			if (stringle[z] == letter) {
				return z;
			}
		}
		return -1;
	}else{return -1;}
}
void cutFAST(char* vstring,int count,int maxlen) {
	int r = 0;
	while (r < maxlen-(count)) {//FIXME: this is not fast, lol (use memmove or something)
		vstring[r] = vstring[r + count];
		r += 1;
	}
	vstring[maxlen-(count)] = 0;
}
void cut(char* vstring, int count) {
	if (count <= 0) {return;}
	int r = strlen(vstring);
	if (count >= r) {strcpy(vstring,"");return;}
	cutFAST(vstring, count, r+1);// include nullterminator
}
int casecomparechars(char c1, char c2) {
	if (c1 == c2) {return 0;}
	if ((c1 >= 'A' && c1 <= 'Z') || (c1 >= 'a' && c1 <= 'z')) {
		if ((c2 >= 'a' && c2 <= 'z') || (c2 >= 'A' && c2 <= 'Z')) {
			if (c2 >= 'A' && c2 <= 'Z') {c2 += 'a'-'A';}
			if (c1 >= 'A' && c1 <= 'Z') {c1 += 'a'-'A';}
			if (c1 == c2) {return 0;}
		}
	}
	return -1;

}
int strcasecmplen(const char* str1, const char* str2, int len) {
	unsigned int r = 0;
	while (r < len && r < strlen(str1) && r < strlen(str2)) {
		if (casecomparechars(str1[r],str2[r]) != 0) {
			return -1;
		}
		r++;
	}
	return 0;
}
int strstw(const char* bigstring,const char* startstring) {
	if (strlen(bigstring) <= 0) {
		if (strlen(startstring) > 0) {
			return -1;
		}else{return 0;}
	}
	if (strlen(startstring) <= 0) {return 0;}
	if (strlen(bigstring) < strlen(startstring)) {
		return -1;
	}
	if (strlen(bigstring) > strlen(startstring)) {
		if (strcasecmplen(bigstring,startstring,strlen(startstring)) == 0) {
			return 0;
		}
		return -1;
	}else{
		if (strcasecmp(bigstring,startstring) == 0) {return 0;}
		return -1;
	}
}
int strendswith(const char* bigstring, const char* endstring) {
	if (strlen(bigstring) < strlen(endstring)) {return -1;}
	if (strlen(bigstring) == strlen(endstring)) {
		if (strcasecmp(bigstring,endstring) == 0) {
			return 0;
		}else{
			return -1;
		}
	}
	//TODO: this can be done with a nice pointer offset instead
	char* buf = alloca(strlen(bigstring)+1);
	strcpy(buf,bigstring);
	cut(buf,strlen(bigstring)-strlen(endstring));
	//printf("comparing %s and %s\n",buf,endstring);
	if (strcasecmp(buf,endstring) == 0) {
		return 0;
	}else{
		return -1;
	}
}
int onlyspaces(const char* vstring) {
	int r = 0;
	while (vstring[r] != 0 && r < 1000) {
		if (vstring[r] != 32 && vstring[r] != 9) {return -1;}
		r += 1;
	}
	return 0;
}
void trimright(char* vstring) {
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	while (vstring[strlen(vstring) - 1] == 32 || vstring[strlen(vstring) - 1] == 9 || vstring[strlen(vstring) - 1] == '\n' || vstring[strlen(vstring) - 1] == '\r') {
		vstring[strlen(vstring) - 1] = 0;//cut last char because it is a space char
		if (strlen(vstring) <= 0) {return;}
	}
}
void trimleft(char* vstring) {
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	while (strstw(vstring," ") == 0 || vstring[0] == 9 || vstring[0] == '\n') {
		cut(vstring,1);
		if (strlen(vstring) <= 0) {return;}
	}
}
void cutonfirstspace(char* vstring) {
	if (strcasecmp(vstring," ") == 0) {strcpy(vstring,"");return;}
	if (strlen(vstring) == 1) {return;}
	if (onlyspaces(vstring) == 0) {strcpy(vstring,"");return;}
	if (vstring == NULL) {return;}
	if (strlen(vstring) < 1) {return;}
	unsigned int fcount2;
	fcount2 = 0;
	if (strlen(vstring) <= 0) {return;}
	while (fcount2 < strlen(vstring)) {
		if (vstring[fcount2] == 32 || vstring[fcount2] == 9|| vstring[fcount2] == '\n') {
			vstring[fcount2] = 0;
			return;
		}
		fcount2 += 1;
	}
}
void linebreaks(char* buf, int len) {
	int z = 0;
	while (z < len-1) {
		if (buf[z] == '\r') {
			buf[z] = '\n';
			if (buf[z+1] == '\n') {
				buf[z+1] = 32;
			}
		}
		z += 1;
	}
}
void addtobuf(char* buf, char byte, unsigned int maxlen) {
	if (strlen(buf) < maxlen-1) {
		buf[strlen(buf)+1] = 0;
		buf[strlen(buf)] = byte;
	}
}
