//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007-2009 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License v3 as published
//    by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define FAKEUSERCOUNT 4
const char** servbotnames[] = {"NicKServ","ChanServ","Global","OperServ"};
#define RECVBUFSIZE 1234
char* fbuf[FAKEUSERCOUNT];
int botuserid[FAKEUSERCOUNT];

int sockets_inited = 0;
void sockets_init() {
	if (sockets_inited == 1) {return;}
	int r = 0;
	while (r < FAKEUSERCOUNT) {
		fbuf[r] = NULL;
		r++;
	}
	sockets_inited = 1;
}

int services_getid(const char* name) {
	sockets_init();
	int r = 0;
	while (r < FAKEUSERCOUNT) {
		if (strcasecmp(servbotnames[r],name) == 0) {
			return r;
		}
		r++;
	}
	return -1;
}
int services_createbot(const char* name, const char* id, const char* host) {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] == NULL) {
			userpointers[r] = malloc(sizeof(struct weircd_user));
			memset(userpointers[r], 0, sizeof(struct weircd_user));
			userpointers[r]->fakeuser = 1;
			userpointers[r]->authed = true;
			userpointers[r]->mode_servicesbot = true;
			userpointers[r]->quitreason = NULL;
			userpointers[r]->hopcount = 0;
			strncpy(userpointers[r]->nickname,name,COMPILEOPTION_MAXNICKLEN);
			userpointers[r]->nickname[COMPILEOPTION_MAXNICKLEN] = 0;
			strncpy(userpointers[r]->suserid,id,COMPILEOPTION_MAXUSERIDLEN);
			userpointers[r]->suserid[COMPILEOPTION_MAXUSERIDLEN] = 0;
			strncpy(userpointers[r]->host,id,COMPILEOPTION_MAXHOSTLEN-1);
			userpointers[r]->host[COMPILEOPTION_MAXHOSTLEN-1] = 0;
#ifdef IPV6
			//is this correct?? or should we insert "::1" instead?? --> yes, we should.
			strcpy(userpointers[r]->ip,"::1");
#endif
#ifndef IPV6
			strcpy(userpointers[r]->ip,"127.0.0.1");
#endif
			strncpy(userpointers[r]->realname,"Services",COMPILEOPTION_MAXREALNAMELEN);
			userpointers[r]->realname[COMPILEOPTION_MAXREALNAMELEN] = 0;
			if (r >= userslotcount) {userslotcount = r+1;}
			FD_SET(socket,&socketset);//add this socket to our select()-file descriptor set
			recalculatenfds();
			return r;
		}
		r++;
	}
}
void services_send(int fakeid, const char* dat) {
	ircdocmd(botuserid[fakeid], dat);
}
void services_process(int fakeid, const char* dat) {
	char data[512];
	strncpy(data,dat,511);data[511] = 0;
	if (charpos(data,'\n') > 0) {data[charpos(data,'\n')] = 0;}
	trimleft(data);
	if (strlen(data) < 1) {return;}
	
}
void services_doreceive(const char* name, const char* dat, int datsize) {
	sockets_init();
	int id = services_getid(name);
	if (id < 0) {return;}
	if (fbuf[id] == NULL) {
		fbuf[id] = malloc(RECVBUFSIZE);
		if (fbuf[id] == NULL) {
			//Pech!1 *olol*
			return;
		}
		strcpy(fbuf[id],"");
	}
	if (strlen(fbuf[id]) + datsize < RECVBUFSIZE) {
		//append new data
		char* lbuf[RECVBUFSIZE];
		int r = 0;
		while (r < datsize) {
			lbuf[r] = dat[r];
			if (lbuf[r] == 0) {lbuf[r] = 32;}
			r++;
		}
		lbuf[datsize] = 0;
		strcat(fbuf[id],lbuf);
		linebreaks_windowstolinux(fbuf[id],strlen(fbuf[id]));
		//check for line breaks and extract lines!
		while (charpos(fbuf[id],'\n') >= 0) {
			
		}
	}else{
		//data exceeds allowed length of 512 per line -> throw it away!
		strcpy(fbuf[id],"");
	}
}
